% test all the models in the testdataset
addpath('.\cjy');
load('.\dataset\test_py')
[~,test_list] = max(test_label,[],2);
model_list = dir('.\cjy\*.mat');
data = load('basic_model');
basic_F1list = zeros(1,10);
for i = 1:10
    prob =  net{i}(test_feature');
    [~,pred] = max(prob);
    basic_F1list(i) = F1score(test_list,pred);
end
xlswrite('basic_model.xlsx',[basic_F1list mean(basic_F1list) std(basic_F1list)])

% some temporary file
for k = 1:numel(model_list)
    F1list = zeros(1,10);
    a = model_list(k).name;
    data = load(a);
    net = data.net;
    pred = zeros(10,size(test_feature,1));

        % to the ga part
    if(a(end-6:end-4) == '_ga')
        excel_file = [a(1:end-3) 'xlsx'];
        optimalw = xlsread(excel_file,1,'A2:J11');

        for i = 1:10
            for j = 1:10
                prob = net{i,j}(test_feature');
                [~,pred(j,:)] = max(prob);
            end
            real_pred = pred(logical(optimalw(i,:)),:);
            ga_pred = mode(real_pred);
            F1list(i) = F1score(test_list,ga_pred);
            [h,p] = ttest(F1list,basic_F1list);
        end
        xlswrite([a '.xlsx'],[F1list mean(F1list) std(F1list) h p]);
    else
         for i = 1:10
            for j = 1:10
                prob = net{i,j}(test_feature');
                [~,pred(j,:)] = max(prob);
            end
            maj_pred = mode(pred);
            F1list(i) = F1score(test_list,maj_pred);
         end
            [h,p] = ttest(F1list,basic_F1list);
         xlswrite([a '.xlsx'],[F1list mean(F1list) std(F1list) h p]);
    end   
end  